package net.mcreator.gts.procedures;

import net.neoforged.neoforge.event.entity.EntityJoinLevelEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.bus.api.Event;

import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.entity.ai.attributes.Attributes;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.effect.MobEffectInstance;

import net.mcreator.gts.init.GtsModMobEffects;
import net.mcreator.gts.entity.TamedCandyEntity;

import javax.annotation.Nullable;

import java.util.ArrayList;

@EventBusSubscriber
public class TamedCandyJoinTheWorldProcedure {
	@SubscribeEvent
	public static void onEntityJoin(EntityJoinLevelEvent event) {
		execute(event, event.getLevel(), event.getEntity());
	}

	public static void execute(LevelAccessor world, Entity entity) {
		execute(null, world, entity);
	}

	private static void execute(@Nullable Event event, LevelAccessor world, Entity entity) {
		if (entity == null)
			return;
		if (!world.isClientSide() && entity instanceof TamedCandyEntity) {
			if (entity instanceof LivingEntity _livingEntity2 && _livingEntity2.getAttributes().hasAttribute(Attributes.EXPLOSION_KNOCKBACK_RESISTANCE))
				_livingEntity2.getAttribute(Attributes.EXPLOSION_KNOCKBACK_RESISTANCE).setBaseValue(100);
			if (entity instanceof TamedCandyEntity _datEntSetI)
				_datEntSetI.getEntityData().set(TamedCandyEntity.DATA_RangeAttack, 0);
			if (entity instanceof TamedCandyEntity _datEntSetI)
				_datEntSetI.getEntityData().set(TamedCandyEntity.DATA_BreachAttack, 0);
			if (entity instanceof TamedCandyEntity _datEntSetL)
				_datEntSetL.getEntityData().set(TamedCandyEntity.DATA_AttackCheck, false);
			if (entity instanceof TamedCandyEntity _datEntSetL)
				_datEntSetL.getEntityData().set(TamedCandyEntity.DATA_ExplosionImmunityCheck, false);
			if (entity instanceof LivingEntity _entity && !_entity.level().isClientSide())
				_entity.addEffect(new MobEffectInstance(GtsModMobEffects.GTS_TIMER, 60, 1, false, false));
			if (entity instanceof Mob _mobSetNoAi) {
				_mobSetNoAi.setNoAi(false);
			}
			for (Entity entityiterator : new ArrayList<>(entity.getPassengers())) {
				entityiterator.stopRiding();
			}
			if (!((entity instanceof TamedCandyEntity _datEntS ? _datEntS.getEntityData().get(TamedCandyEntity.DATA_AnimationDecision) : "").equals("candy.sleep"))
					&& !((entity instanceof TamedCandyEntity _datEntS ? _datEntS.getEntityData().get(TamedCandyEntity.DATA_AnimationDecision) : "").equals("candy.sit"))) {
				if (entity instanceof TamedCandyEntity _datEntSetS)
					_datEntSetS.getEntityData().set(TamedCandyEntity.DATA_AnimationDecision, "empty");
			}
		}
	}
}
