package net.mcreator.gts.procedures;

import net.neoforged.neoforge.event.entity.EntityMountEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.bus.api.ICancellableEvent;
import net.neoforged.bus.api.Event;

import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.entity.Entity;

import net.mcreator.gts.entity.TokiEntity;
import net.mcreator.gts.entity.CandyEntity;

import javax.annotation.Nullable;

@EventBusSubscriber
public class TokiDismountActionProcedure {
	@SubscribeEvent
	public static void onEventTriggered(EntityMountEvent event) {
		execute(event, event.getLevel(), event.getEntityBeingMounted(), event.getEntityMounting(), event.isDismounting());
	}

	public static void execute(LevelAccessor world, Entity entity, Entity sourceentity, boolean DISMOUNTING) {
		execute(null, world, entity, sourceentity, DISMOUNTING);
	}

	private static void execute(@Nullable Event event, LevelAccessor world, Entity entity, Entity sourceentity, boolean DISMOUNTING) {
		if (entity == null || sourceentity == null)
			return;
		if (!world.isClientSide() && DISMOUNTING) {
			if (entity instanceof TokiEntity) {
				if (!(entity instanceof TokiEntity _datEntL2 && _datEntL2.getEntityData().get(TokiEntity.DATA_ThrowingTarget)) && sourceentity.isAlive() && entity.isAlive()) {
					if (event instanceof ICancellableEvent _cancellable) {
						_cancellable.setCanceled(true);
					}
				} else {
					if (entity instanceof TokiEntity _datEntSetL)
						_datEntSetL.getEntityData().set(TokiEntity.DATA_ThrowingTarget, false);
					sourceentity.getPersistentData().putBoolean("BeingGrabbed", false);
				}
			} else if (entity instanceof CandyEntity) {
				if (!(entity instanceof CandyEntity _datEntL8 && _datEntL8.getEntityData().get(CandyEntity.DATA_ThrowingTarget)) && sourceentity.isAlive() && entity.isAlive()) {
					if (event instanceof ICancellableEvent _cancellable) {
						_cancellable.setCanceled(true);
					}
				} else {
					if (entity instanceof CandyEntity _datEntSetL)
						_datEntSetL.getEntityData().set(CandyEntity.DATA_ThrowingTarget, false);
					sourceentity.getPersistentData().putBoolean("BeingGrabbed", false);
				}
			}
		}
	}
}
